<?php
chdir("..");
include "./includes/variables.php";
include "./misc/database.php";
include "./includes/amifunc.php";
include '/usr/local/php/beroConf.php';
$bc = new beroConf('root');
$ba = new beroAri();
$ami=new amifunc();
function group_reg($ba){
	$query=$ba->select("select * from general");
	while ($entry = $ba->fetch_array($query)) {
		$ret=$entry['rules'];
	}
	return $ret;
}
function logserver($ba){
	$query=$ba->select("select * from general");
	while ($entry = $ba->fetch_array($query)) {
		$ret=$entry['logserver'];
	}
	return $ret;
}
function logging_active($ba){
	$query=$ba->select("select * from general");
	while ($entry = $ba->fetch_array($query)) {
		$ret=$entry['logging_active'];
	}
	return $ret;
}
//isgw.conf
$file_isgw="/usr/conf/isgw.conf";
$isgw_cont="[general]\n";
$query=$ba->select("select * from general");
while ($entry = $ba->fetch_array($query)) {
	$isgw_cont.="statusport=54322\n";
	$isgw_cont.="logserver=".$entry['logserver']."\n";
	$isgw_cont.="logging_active=".$entry['logging_active']."\n";
	$isgw_cont.="loglevel=".$entry['loglevel']."\n";
	$isgw_cont.="telnet_acl=".$entry['telnet_acl']."\n";
	if ($ba->get("syslog_facility")!="") $isgw_cont.="syslog_facility=".$ba->get("syslog_facility")."\n";
	else $isgw_cont.="syslog_facility=16\n";
	//$isgw_cont.="udpports=".$entry['udpports']."\n";
}
        
	if ($ba->get("rtp_traffic")!="") $isgw_cont.="rtp_traffic=".$ba->get("rtp_traffic")."\n";
	else $isgw_cont.="rtp_traffic=0\n";
        
	$q=$ba->select("select type, lif, master from isdn group by type,lif, master order by lif");
	$i=0;
	while ($ent=$ba->fetch_array($q)){
		$li[$i]=$ent['lif'];
		$mast[$i]=$ent['master'];
		$i++;
	}
	if ($mast[0]=="1" && $mast[1]=="1"){
		$isgw_cont.="msp_bridging=ON_SAME_BUS_ONLY\n";
	}elseif ($mast[0]=="0" && $mast[1]=="1"){
		$isgw_cont.="msp_bridging=YES\n";
	}elseif ($mast[0]=="1" && $mast[1]=="0"){
		$isgw_cont.="msp_bridging=YES\n";
	}

if (!file_exists($file_isgw)){
	$fp= fopen($file_isgw,"w+");
	$write=fputs($fp,$isgw_cont);
	fclose($fp);
}else if (file_exists($file_isgw)){
	$fp= fopen($file_isgw,"w+");
	$write=fputs($fp,$isgw_cont);
	fclose($fp);
}

//isgw.sip
$file_sip="/usr/conf/isgw.sip";
$sip_cont="[general]\n";
$query=$ba->select("select * from sip_general");
while ($entry = $ba->fetch_array($query)) {
	$sip_cont.="sip_address=sip:0.0.0.0:".$entry['bindport']."\n";
	if ($entry['udpports']!="")
	$sip_cont.="udpports=".$entry['udpports']."\n";
	if ($ba->get("sip_over_tcp")=="1" || $ba->get("sip_over_tcp")=="yes")
	$sip_cont.="sip_over_tcp=1\n";
	else
	$sip_cont.="sip_over_tcp=0\n";
	$sip_cont.="externip=".$entry['externip']."\n";
}

$query_sip=$ba->select("select * from sip");

while ($entry = $ba->fetch_array($query_sip)) {
	$sip_cont.="[".$entry['name']."]\n";
	$sip_cont.="address = ".$entry['server_address']."\n";
	$sip_cont.="type = ".$entry['type']."\n";
	$sip_cont.="user = ".$entry['user']."\n";
	$sip_cont.="secret = ".$entry['secret']."\n";
	if ($entry['type']!='proxy') $sip_cont.="regrefresh = ".$entry['regrefresh']."\n";
	$sip_cont.="externip = ".$entry['externip']."\n";
	//$sip_cont.="stunserver = ".$entry['stunserver']."\n";
	$sip_cont.="config = ".$entry['config']."\n";
	$sip_cont.="default = ".$entry['def']."\n\n";
}
if (!file_exists($file_sip)){
	$fp= fopen($file_sip,"w+");
	$write=fputs($fp,$sip_cont);
	fclose($fp);
}else if (file_exists($file_sip)){
	$fp= fopen($file_sip,"w+");
	$write=fputs($fp,$sip_cont);
	fclose($fp);
}

//isgw.isdn
$file_isdn="/usr/conf/isgw.isdn";
$isdn_cont.="[general]\n";
$isdn_cont.="time_from_isdn=".$bc->get("root", "time_from_isdn")."\n\n" ;
$query = $ba->select('SELECT DISTINCT gr FROM isdn WHERE gr!="NULL"');
while ($entry = $ba->fetch_array($query)) {
	$queryc = $ba->select('SELECT config FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$config="";
	while ($entryc = $ba->fetch_array($queryc)) {
		$config.=$entryc['config'];
	}
	$query_ch = $ba->select('SELECT chansel FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$chansel="";
	while ($entrych = $ba->fetch_array($query_ch)) {
		$chansel.=$entrych['chansel'];
	}
	$query_odt = $ba->select('SELECT odt FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$odt="";
	while ($entryodt = $ba->fetch_array($query_odt)) {
		$odt.=$entryodt['odt'];
	}
	$query_odt_e = $ba->select('SELECT odt_empty_dad FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$odt_empty_dad="";
	while ($entryodte = $ba->fetch_array($query_odt_e)) {
		$odt_empty_dad.=$entryodte['odt_empty_dad'];
	}
	$query_to = $ba->select('SELECT tones FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$tones="";
	while ($entryto = $ba->fetch_array($query_to)) {
		$tones.=$entryto['tones'];
	}
	$query_ovd = $ba->select('SELECT overlap_dialing FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$overlap_dialing="";
	while ($entryovd = $ba->fetch_array($query_ovd)) {
		$overlap_dialing.=$entryovd['overlap_dialing'];
	}
	$query_qsig = $ba->select('SELECT qsig FROM isdn WHERE gr="'.$entry['gr'].'" group by gr');
	$qsig="";
	while ($entryqsig = $ba->fetch_array($query_qsig)) {
		$qsig.=$entryqsig['qsig'];
	}
	$query_port = $ba->select('SELECT port FROM isdn WHERE gr="'.$entry['gr'].'" ORDER BY port asc');
	$ports="";
	while ($entryp = $ba->fetch_array($query_port)) {
		if($ports!=""){
			$ports.=",".$entryp['port'];
		}else{
			$ports.=$entryp['port'];
		}
	}
	$isdn_cont.="[".$entry['gr']."]\n";
	$isdn_cont.="ports = ".$ports."\n";
	$isdn_cont.="config = ".$config."\n";
	$isdn_cont.="chansel = ".$chansel."\n";
	$isdn_cont.="tones = ".$tones."\n";
	$isdn_cont.="overlap_dial_timeout = ".$odt."\n";
	$isdn_cont.="overlap_dial_timeout_empty_dad = ".$odt_empty_dad."\n";
	$isdn_cont.="overlap_dialing = ".$overlap_dialing."\n";
	$isdn_cont.="qsig = ".$qsig."\n";

}

if (!file_exists($file_isdn)){
	$fp= fopen($file_isdn,"w+");
	$write=fputs($fp,$isdn_cont);
	fclose($fp);
}else if (file_exists($file_isdn)){
	$fp= fopen($file_isdn,"w+");
	$write=fputs($fp,$isdn_cont);
	fclose($fp);
}

//isdn.conf
$file_isdnhw="/usr/conf/isdn.conf";
$query = $ba->select('SELECT type  FROM isdn WHERE lif=1');
if (sqlite_fetch_single($query)==""){
	$lif1="none";
}
$query = $ba->select('SELECT type  FROM isdn WHERE lif=0');
$isdn_hw_cont="[lif0]\n";
if (sqlite_fetch_single($query)!=""){
	$type=sqlite_fetch_single($query);
	$isdn_hw_cont.="type=".$type."\n";
	
	$ntteSW="";
	$ntteHW="";
	$termination="";
	$ptp="";
	$master="";
	$clock="0";
	$query = $ba->select('SELECT * FROM isdn WHERE lif=0 order by port');
	while ($entry = $ba->fetch_array($query)) {
		if ($ntteSW=="") $ntteSW=$entry['ntteSW'];
		else $ntteSW.=",".$entry['ntteSW'];
		
		if ($ntteHW=="") $ntteHW=$entry['ntteHW'];
		else $ntteHW.=",".$entry['ntteHW'];
		
		
		if ($termination=="") $termination=$entry['lt'];
		else $termination.=",".$entry['lt'];
		
		
		if ($ptp=="") $ptp=$entry['ptp'];
		else $ptp.=",".$entry['ptp'];
		
		if ($entry['clock']=="1") $clock=$entry['port'];
	
		$master=$entry['master'];
	}
	$isdn_hw_cont.="master=".$master."\n";
	if ($clock!="") $isdn_hw_cont.="clock=".$clock."\n";
	$isdn_hw_cont.="ntteSW=".$ntteSW."\n";
	$isdn_hw_cont.="ntteHW=".$ntteHW."\n";
	if ($type!="bf2E1" && $type!="bf1E1") $isdn_hw_cont.="termination=".$termination."\n";
	
	$revision=exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
	if ($lif1=="none" && $type=="bf4S0" && $revision!="1.80") {
		$q=$ba->select('SELECT value FROM key_val WHERE key="portswitch"');
		$v=sqlite_fetch_single($q);
		$isdn_hw_cont.="portswitch=".$v."\n";
	}elseif ($type=="bf4S0"){
		$isdn_hw_cont.="portswitch=0\n";
	}
	
	$isdn_hw_cont.="ptp=".$ptp."\n\n";
		
}else{
	$isdn_hw_cont.="type=none\n\n";
}

$query = $ba->select('SELECT type  FROM isdn WHERE lif=1');
$isdn_hw_cont.="[lif1]\n";
$type=sqlite_fetch_single($query);
if ($type!=""){
	$isdn_hw_cont.="type=".$type."\n";
	$ntteSW="";
	$ntteHW="";
	$termination="";
	$ptp="";
	$master="";
	$clock="0";
	$query = $ba->select('SELECT * FROM isdn WHERE lif=1 order by port');
	while ($entry = $ba->fetch_array($query)) {
		if ($ntteSW=="") $ntteSW=$entry['ntteSW'];
		else $ntteSW.=",".$entry['ntteSW'];
		
		if ($ntteHW=="") $ntteHW=$entry['ntteHW'];
		else $ntteHW.=",".$entry['ntteHW'];
		
		
		if ($termination=="") $termination=$entry['lt'];
		else $termination.=",".$entry['lt'];
		
		
		if ($ptp=="") $ptp=$entry['ptp'];
		else $ptp.=",".$entry['ptp'];
		
		if ($entry['clock']=="1"){
			 $q=$ba->select('SELECT * FROM isdn WHERE lif=0 order by port');
			 $clock=$entry['port']-sqlite_num_rows($q);
		}
		$master=$entry['master'];
	}
	$isdn_hw_cont.="master=".$master."\n";
	if ($clock!="") $isdn_hw_cont.="clock=".$clock."\n";
	$isdn_hw_cont.="ntteSW=".$ntteSW."\n";
	$isdn_hw_cont.="ntteHW=".$ntteHW."\n";
	if ($type=="bf4S0"){
		$isdn_hw_cont.="portswitch=0\n";
	}
	if ($type!="bf2E1" && $type!="bf1E1") $isdn_hw_cont.="termination=".$termination."\n";
		$isdn_hw_cont.="ptp=".$ptp."\n\n";
	}else{
		$isdn_hw_cont.="type=none\n\n";
	}
$isdn_hw_cont.="[pcm]\ntype=pcm\nmaster=0\n";
if (!file_exists($file_isdnhw)){
	$fp= fopen($file_isdnhw,"w+");
	$write=fputs($fp,$isdn_hw_cont);
	fclose($fp);
}else if (file_exists($file_isdnhw)){
	$fp= fopen($file_isdnhw,"w+");
	$write=fputs($fp,$isdn_hw_cont);
	fclose($fp);
}

//misc.conf
$file_misc="/usr/conf/misc.conf";
$m_cont="";
$m_cont.="[general]\n";
$m_cont.="ntphost=".$bc->get("root", "ntphost")."\n";
$m_cont.="timezone=".$bc->get("root", "timezone")."\n";
//$m_cont.="root-version=".$bc->get("root", "root-version")."\n";
$m_cont.="lan-iface=".$bc->get("root", "lan-iface")."\n";
$m_cont.="lan-ipaddr=".$bc->get("root", "lan-ipaddr")."\n";
$m_cont.="lan-netmask=".$bc->get("root", "lan-netmask")."\n";
$m_cont.="lan-gateway=".$bc->get("root", "lan-gateway")."\n";
$m_cont.="msp-iface=".$bc->get("root", "msp-iface")."\n";
$m_cont.="msp-ipaddr=".$bc->get("root", "msp-ipaddr")."\n";
//$m_cont.="app-image=".$bc->get("root", "app-image")."\n";
//$m_cont.="app-status=".$bc->get("root", "app-status")."\n";
$m_cont.="lan-mtu=".$bc->get("root", "lan-mtu")."\n";
$m_cont.="use-boot-prov=".$bc->get("root", "use-boot-prov")."\n";
$m_cont.="tftp-host=".$bc->get("root", "tftp-host")."\n";
$m_cont.="tftp-url=".$bc->get("root", "tftp-url")."\n";
$m_cont.="provisioning-option=".$bc->get("root", "provisioning-option")."\n";
$m_cont.="lan-dhcp=".$bc->get("root", "lan-dhcp")."\n";
$m_cont.="lan-nameserver=".$bc->get("root", "lan-nameserver")."\n";
$m_cont.="summer_winter_time=".$ba->get("summer_winter_time")."\n";
$m_cont.="bnfos-ipaddr=".$ba->get("ip_berofos")."\n";
$m_cont.="bnfos-mac=".$ba->get("mac_berofos")."\n";
$m_cont.="bnfos-intv=".$ba->get("interval_berofos")."\n";
$m_cont.="bnfos-hb-on-boot=".$bc->get("root", "use_boot_bnfoswdog")."\n";
$query = $ba->select('SELECT * FROM users where user!="beroAdmin"');
	while ($entry = $ba->fetch_array($query)) {
		$admin_user=$entry['user'];
		$admin_pass=$entry['password'];
	}
$query = $ba->select('SELECT show_app FROM set_app');
	while ($entry = $ba->fetch_array($query)) 
		$sessions_disable=$entry['show_app'];
$m_cont.="admin-pass=".$admin_pass."\n";
$m_cont.="admin-user=".$admin_user."\n";
$m_cont.="sessions-disable=".$sessions_disable."\n";

$apiuser_file = "/usr/conf/apiusers.conf";
if (file_exists($apiuser_file)){
	$cont = file($apiuser_file);
	$m_cont.="api-pass=" . $cont[0] . "\n";
}
$wr=$m_cont;
if (!file_exists($file_misc)){
	$fp= fopen($file_misc,"w+");
	$write=fputs($fp,$wr);
	fclose($fp);
}else if (file_exists($file_misc)){
	$fp= fopen($file_misc,"w+");
	$write=fputs($fp,$wr);
	fclose($fp);
}


//isgw.causes
$file_causes="/usr/conf/isgw.causes";
$c_cont="";
$causes_active=$ba->get("causes_active");
if ($causes_active==""){
	$causes_active=$ba->get("causes_default");
	$c_cont=$causes_active;
}else{
	$c_cont=$causes_active;
}
$wr=$c_cont;
if (!file_exists($file_causes)){
	$fp= fopen($file_causes,"w+");
	$write=fputs($fp,$wr);
        fclose($fp);
        system("/usr/bin/dos2unix -u $file_causes", $retval);
}else if (file_exists($file_causes)){
	$fp= fopen($file_causes,"w+");
	$write=fputs($fp,$wr);
	fclose($fp);
        system("/usr/bin/dos2unix -u $file_causes", $retval);
}



//isgw.dialplan
$file_dialplan="/usr/conf/isgw.dialplan";
$d_cont=";From\tTo\tFromID\tToID\tDestination\tNewDestination\tSource\tNewSource\tConfig\n";
$query_d=$ba->select("select * from dialplan");
while ($entry = $ba->fetch_array($query_d)) {
		$fr_to=split("-",$entry['direction']);
		$d_cont.=$fr_to[0]."\t";
		$d_cont.=$fr_to[1]."\t";
		/*if (($entry['direction']=="sip-isdn") && (stripos($entry['fromId'],"p:")==0) && (stripos($entry['fromId'],"p:")!==false) ){
			$name=split(":",$entry['fromId']);
			$q=$ba->select("select server_address from sip where name='".$name[1]."'");
			$d_cont.="(".sqlite_fetch_single($q).")\t";
		}else{
			$d_cont.=stripslashes($entry['fromId'])."\t";
		}*/
		$d_cont.=stripslashes($entry['fromId'])."\t";		
		$d_cont.=stripslashes($entry['toId'])."\t";
		$d_cont.=stripslashes($entry['dest'])."\t";
		$d_cont.=stripslashes($entry['newDest'])."\t";
		$d_cont.=stripslashes($entry['src'])."\t";
		$d_cont.=stripslashes($entry['newSrc'])."\t";
		$d_cont.=stripslashes($entry['config'])."\n";
}
$wr=$d_cont;
if (!file_exists($file_dialplan)){
	$fp= fopen($file_dialplan,"w+");
	$write=fputs($fp,$wr);
	fclose($fp);
}else if (file_exists($file_dialplan)){
	$fp= fopen($file_dialplan,"w+");
	$write=fputs($fp,$wr);
	fclose($fp);
}


$query=$ba->select("select option from activate where id='activate'");
while($entry = $ba->fetch_array($query)){
	if ($entry['option']==3){
		$query=$ba->update("update activate SET option=0 where id='activate'");
		echo "<html>
			<body>
			<form class='beroari_form' action='../index.php?m=rebres' method='POST' name='reboot'>
			<input type='hidden' name='action' value='reboot'>
			<input type='hidden' name='v' value='Yes'>
			</form>
			<script>document.reboot.submit();</script>
			</body>
			</html>";
	}elseif ($entry['option']==2){
		exec('/usr/local/init/S50isgw restart',$ausgabe);
	}elseif ($entry['option']==1){
		require_once "./includes/isgwtelnet.php";
                $isgw = new isgwtelnet();
                $result=$isgw->isgw_login();
                $reload=$isgw->isgw_dialplanreload();
                $sip_reload=$isgw->isgw_sipreload();
	}
}
if (!$ba->is_error()){
	$query=$ba->update("update activate SET option=0 where id='activate'");
}
if ($ba->is_error()){
	echo "<script>alert('".$ba->error()."');</script>";
}
echo "<script>window.location='../index.php?m=".$_GET['m']."'</script>";

