
function verifyIP (IPvalue) {
	errorString = "";
	theName = "IPaddress";

	var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
	var ipArray = IPvalue.match(ipPattern);

	if (ipArray == null)
		errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
	else {
		for (var i = 1; i <= 4; i++) {
			thisSegment = ipArray[i];
			if (thisSegment > 255) {
				errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
				i = 5;
			}
		}
	}
	if (errorString == ""){
		return true;
	}else{
		alert (errorString);
		return false;
	}
}


function checkvlan(ch,val){
	if (ch){
		if (val>=1 && val<=4094) return true;
		else{
			alert("VLAN id may be a number between 1 and 4094");
			return false;
		}
	}else return true;
	
}

function sip_general_val(bind_port,rtp_range){
	var ranges=rtp_range.split(',');
	var count=0;
	for (i=0; i<ranges.length;i++){
		var values=ranges[i].split("-");
		// && values[1] >= bind_port		
		if ( parseInt(values[0]) <= parseInt(bind_port) && parseInt(values[1])>= parseInt(bind_port)){
			alert('The Bind Port is false');
			return false;
		}
		count+=values[1]-values[0];
	}
	
	if (count<240 || !isNaN(rtp_range)){
		alert('The number of RTP ports must be at least 240');
		return false
	}
	return true;
}

function testLength(value,len,name){
	if(value.length>len){
		alert(name +' can have a maximum of ' + len + ' characters');
		return false;
	}
	return true;
}

function verifyUsername(value,session){
	if (value=="beroAdmin" && session!="beroAdmin"){
		alert("The username may not be beroAdmin");
		return false;
	}
	return true;
}

function specChar(value,name)  { 	
	var iChars = "!@#$%^&*()+=[]\';,/{}|\":<>?";   
	for (var i = 0; i < value.length; i++) {   
		if (iChars.indexOf(value.charAt(i)) != -1)    
		{   	
			alert(name+" contains special characters. These are not allowed. Please remove them and try again.");  
			return false;  
		}  
	}   
	return true;
}  


function limited(text,max)
{
	if (text.value.length>=max){
		text.value=text.value.substring(0,max);
	}
	document.getElementById("zz").innerHTML = text.value.length + ", Rest " + (max - text.value.length);
}

function is_not_empty(ftext, name){
	if (ftext==""){
		alert("Please fill the " + name + " field.");
		return false;
	}else{
		return true;
	}
}

 
function verify_number(ftext, name){
 	if (is_not_empty(ftext, name)){
 	 	if (isNumber(ftext)){
 	 		return true;
		}else{
			alert(name + " may be a number.");
			return false;
		}
	}else{
		return false;
	}
 	return false;
}

function verify_range(ftext, name){
	if (is_not_empty(ftext, name)){
		if (ftext==0 || ftext==8 || ftext==16 || ftext==24 || ftext==32){
			return true;
		}else{
			alert(name + " may be 0, 8, 16, 24 or 32");
			return false;
		}
	}else{
		return false;
	}
}
function isNumber(str) {
  for(var position=0; position<str.length; position++){
	var chr = str.charAt(position)
        if  ( (chr < "0") || (chr > "9") ) 
              return false;
  };      
  return true;
};

function check_blank(val, name){
	if (val.indexOf(" ")!=-1){
		alert ("The " + name + " may not contain blanks");
		return false;
	}
	return true;
}
