<?php


/**
 * Klasse Isgw_causes
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */

class Isgw_causes {
	
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {
		
		// args
		$m = $_GET['m'];
		
		include('./includes/header.php');
		$causes_table = $this->dynamic_table();
		// build page content
		$ret .= "
					<form class='extensions_form' name='isgw_causes' action='' method='POST' >
					<input type=hidden name=m value=" . $m . ">
					<input type=hidden name=a value='save'>
					<br>
					" . $causes_table;

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}


	
	/*
	 * Syslog select box wird, mit den in der Datenbank gespeicherten Daten, erzeugt 
	 * und nachher angezeigt.
	 */
	function get_causes(){
		$ba = new beroAri();
		$causes_active=$ba->get("causes_active");
		if ($causes_active==""){
			$causes_active=$ba->get("causes_default");
			$textarea="<textarea name='causes' id='causes' cols='100' rows='45' wrap='physical' onKeyDown='return catchTab(this,event);'>".$causes_active."</textarea>";
		}else{
			$textarea="<textarea name='causes' id='causes' cols='100' rows='45' wrap='physical' onKeyDown='return catchTab(this,event);'>".$causes_active."</textarea>";
		}
		return $textarea;
	}
	
	function get_default(){
		$ba = new beroAri();
		$causes_active=$ba->get("causes_default");
		$textarea="<textarea name='causes' id='causes' cols='100' rows='45' wrap='physical' onKeyDown='return catchTab(this,event);'>".$causes_active."</textarea>";

		return $textarea;
	}


	
	
	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
		//Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
		//aktualisiert
		if (isset($_POST['save']) && isset($_POST['causes'])) {
			$ba = new beroAri();
			$ba->set("causes_active",$_POST['causes']);
			$query=$ba->select("select option from activate");
			while($entry = $ba->fetch_array($query)){
				if ($entry['option'] <= 2){
					$query =  $ba->update("UPDATE activate SET option=2");
					$table.= "<script>aktivieren(1,'causes','2');</script>";
				}
			}
		}
				
		$table .= "<table class='contenttoc' id='table'>
					<tr>
					<th>Causes map</th>
					</tr>
					<tr>
					<td>";
					if (isset($_POST['load_def'])) $table.=$this->get_default(); 
					else  $table.=$this->get_causes();
					$table.="</td>
					</tr>
					<tr>
					<td><input name='save' type='submit' value='Save' onmouseover=\"Tip('" . GENERAL_SAVE . "')\" onmouseout='UnTip()'>
					<input name='load_def' type='submit' value='Load default' onmouseover=\"Tip('" . ISGW_CAUSES_LOAD_DEF . "')\" onmouseout='UnTip()'>
					</td>
					</tr>
					</table>
					<br>
					</form>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf 					
		return $table;
	}

}
?>
