<?php


/**
 * Class for network settings
 */
class Net_conf {

	
	function display($args) {
		include('./includes/header.php');
		$ret.="<script>
			function check(val){
 			       if (val<500 || val>1500){
			                alert (\"The MTU Size may be between 500 and 1500\");
			                return false;
			       }else{
			                return true;
			       }
			}	
		</script>";
		include '/usr/local/php/beroConf.php';
		$image_dir = "/mnt/images";
		$files = 0;
		$bc = new beroConf('root');
		$ba= new beroAri();

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		$start = $_GET['start'];
		if (!$bc->valid()) {
			$ret.= '<h3>Error:</h3><b>Failed to connect to config database!</b><br>';
			exit(0);
		}
		
		

		switch ($_POST['action']) {
			case 'apply':
				if ($_POST['ipaddr']!=$_POST['gateway']){
				$bc->set("root", "lan-dhcp", $_POST['dhcp']);
				$bc->set("root", "lan-ipaddr", $_POST['ipaddr']);
				$bc->set("root", "lan-netmask", $_POST['netmask']);
				$bc->set("root", "lan-gateway", $_POST['gateway']);
				$bc->set("root", "lan-mtu", $_POST['lan_mtu']);
				$bc->set("root", "lan-nameserver", $_POST['lan-nameserver']);
							
				$ret.=exec("if /usr/sbin/netconfigverify ".$_POST['ipaddr']." ".$_POST['netmask']." ".$_POST['gateway']." 2>&1 | /bin/grep Failed ;
				 then 
				 /bin/echo \<br\>\<b\>\<font color\=red\>FAILED\<\/font\>\<\/b\>; 
				 else 
				 /usr/local/sbin/update-network > /dev/null 2>&1 > /dev/null; 
				 
				 /bin/echo \<br\>\<b\>\<font color\=red\>Configuration applied\<\/font\>\<\/b\>; 
				 fi");			
			 	}else{
			 		$ret.= "<br><b><font color=red>FAILED</font></b>";
				}	
				break;
		}
		$iface = $bc->get("root", "lan-iface");
		$dhcp = strcasecmp("yes", $bc->get("root", "lan-dhcp")) == 0;
		$ret.='<form class="extensions_form" name="networkform" method="POST" action="" onsubmit="return (verifyIP(ipaddr.value) && verifyIP(netmask.value) && verifyIP(gateway.value) && check(lan_mtu.value));">
			<input type="hidden" name="action" value="apply">
			<table id="table" class="contenttoc">
				<tr>
				<th colspan="2">Network Settings</th>
				</tr>
				<tr>
					<td colspan="2" align="center">
						<input type="radio" name="dhcp" onmouseover=\'Tip("' . NET_CONF_DHCP . '")\' onmouseout="UnTip()" value="yes"' . ( $dhcp ? ' checked' : '' ) . '>DHCP</input>
						<input type="radio" name="dhcp" onmouseover=\'Tip("' . NET_CONF_STATIC . '")\' onmouseout="UnTip()" value="no"' . ( $dhcp ? '' : ' checked' ) . '>Static</input>
					</td>
				</tr>
				<tr>
					<td style="text-align:center">IP-Address: </td>
					<td>
						<input name="ipaddr" type="text" size="15" id="ipaddr" onmouseover=\'Tip("' . NET_CONF_IP_ADDRESS . '")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-ipaddr") . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center">Netmask: </td>
					<td>
						<input name="netmask" type="text" size="15" id="netmask" 
							onclick="if (netmask.value==\'\') netmask.value=makeNetMask(ipaddr.value);" 
							onmouseover=\'Tip("' . NET_CONF_NETMASK . '")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-netmask") . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center">Gateway: </td>
					<td>
						<input name="gateway" type="text" size="15" id="gateway" onmouseover=\'Tip("' . NET_CONF_GATEWAY . '")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-gateway") . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center">MTU size: </td>
					<td>
						<input name="lan_mtu" type="text" size="15" id="lan_mtu" onmouseover=\'Tip("'.NET_CONF_MTU_SIZE.'")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-mtu") . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center">Name Server: </td>
					<td>
						<input name="lan-nameserver" type="text" size="15" id="lan-nameserver" onmouseover=\'Tip("'.NET_CONF_NAMESERVER.'")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-nameserver") . '">
					</td>
				</tr>
				<tr>
					<td colspan="2" align="center">
						<input type="reset" name="reset" value="Reset" onmouseover=\'Tip("' . NET_CONF_RESET . '")\' onmouseout="UnTip()">&nbsp;
						<input type="submit" name="Apply" value="Save" onmouseover=\'Tip("' . NET_CONF_APPLY . '")\' onmouseout="UnTip()">
					</td>
				</tr>
			</table>
			</form>';

		return $ret;
	}

				
}


?>
