<?php


/**
 * Klasse Debug
 */

class Fulltrace {
	/*
	 * Die Funktion ports wird benutzt um alle ISDN Ports anzuzeigen.
	 */
	function ports() {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$qu = $ba->select("select * from isdn");
		//Alle Einträge von der Abfrage werden durchgelaufen
		while ($entry = $ba->fetch_array($qu)) {
			//Für jede Port wird ein checkbox erzeugt
			$select .= "<input type=checkbox name='ports[]' value='" . $entry['port'] . "' checked>" . $entry['port'] . "&nbsp;
			&nbsp;";

		}
		//Alle checkboxs werden zurückgegeben*/
		return $select;
	}

	function udp() {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$qu = $ba->select("select bindport from sip_general");
		return sqlite_fetch_single($qu);
	}
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {
		
		$ba = new beroAri();

		require_once "./includes/amifunc.php";
		include('./includes/header.php');
		require_once ('./includes/isgwtelnet.php');
		$ret.= "<script language='javascript'>function checkallp(){
			var checkall = document.getElementById('checkall');
		var del = document.getElementsByName('ports[]');
		if (checkall.checked==true){
			for (i=0; i < del.length; i++){
				del[i].checked=true;
			}
		}else{
			for (i=0; i < del.length; i++){
				del[i].checked=false;
			}
		}

	}
	function dis(){
		var isdn_enable = document.getElementById('isdn_enable');
		var checkall = document.getElementById('checkall');
		var del = document.getElementsByName('ports[]');
		if (isdn_enable.checked==true){
			checkall.disabled=false;
			for (i=0; i < del.length; i++){
				del[i].disabled=false;
			}
		}else{
			checkall.disabled=true;
			for (i=0; i < del.length; i++){
				del[i].disabled=true;
			}
		}
	}
	</script>";
	
	//Die Tabelle MISDN Trace 
	if (($ba->get("trace")=="" || $ba->get("trace")=="no") && !isset($_POST['trace'])) {
		$ret .= "<br/><form class='extensions_form' method='POST'>
			<table class='contenttoc' id='table'>
			<tr><th colspan='2'>Full Trace</th></tr>
			<tr>
			<td>ISDN Ports</td><td>SIP</td>
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>enable
			<br/>
			<b>Check&nbsp;All</b>
			<input type='checkbox' id='checkall' name='checkall' onclick='checkallp();' onmouseover=\"Tip('".DEBUG_CHECK_ALL."')\" onmouseout='UnTip()'>
			<br/>" . $this->ports() . 
			"<br/>
			<br/>
			</td>
			<td>
			<input type='checkbox' name='sip_sign' id='sip_sign' value='1' onclick='if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;' checked/>Sip Sign
			<br/>
			<input type='checkbox' name='sip_audio' id='sip_audio' value='1' /><label for='sip_audio'>Sip Audio</label>
			</td>
			</tr>
			<tr>
			<td>
			<img src='./includes/images/punkt_rot.gif'></td>
			<td>
			<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_START_TRACE."')\" onmouseout='UnTip()' value='Start'>
			</td>
			</tr>";
		/* Wenn man auf den Knopf Start geclickt hat, wird die module mISDN_debugtool.ko geladen
		   und das mISDNdebugtool mit den ausgewählten Ports ausgeführt */
	}elseif ($_POST['trace'] == "Start" ) {
		$ports = "";
		if ($_POST['ports']) {
			foreach ($_POST['ports'] as $value) {
				if ($ports != "")
					$ports .= "," . $value;
				else
					$ports .= $value;
			}
		}
		if (($ports != "" && $_POST['isdn_enable']=='1') || ($_POST['sip_sign']=='1')) {
			//Loglevel auf das Maximum erhöhen.
			$isgw = new isgwtelnet();	
			$isgw->isgw_login();
  			$isgw->logactive(1);
  			$isgw->loglevel(9);
  			$isgw->lla();
  			
			$ba->set("trace","yes");
			if ($ports != "" && $_POST['isdn_enable']=='1'){
				exec("/sbin/insmod /usr/local/modules/mISDN_debugtool.ko");
				exec("/usr/local/bin/mISDNdebugtool -d -s 5000 -f /tmp/ISDNdebug -p " . $ports);
			}
			if ($_POST['sip_sign']=='1' && $_POST['sip_audio']=='1'){
				exec("/usr/local/sbin/tcpdump -s0 -w /tmp/tcpDump -C 2 > /dev/null &");
				exec("/usr/local/sbin/tcpdump -i lo -s0 -w /tmp/tcpDump.lo -C 2 > /dev/null &");
			}
			
			if ($_POST['sip_sign']=='1' && !isset($_POST['sip_audio'])){
				exec("/usr/local/sbin/tcpdump -s0 -w /tmp/tcpDump -C 2 udp port ".$this->udp()." > /dev/null &");
				exec("/usr/local/sbin/tcpdump -i lo -s0 -w /tmp/tcpDump.lo -C 2 udp port ".$this->udp()." > /dev/null &");
			}
			
			$ret .= "<br/><form class='extensions_form' method='POST'>" .
				"<table class='contenttoc'><tr><th colspan='2'>Full Trace</th></tr><tr>" .
				"<td><img src='./includes/images/punkt_gruen.gif'></td>
				<td>
				<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_STOP_TRACE."')\" onmouseout='UnTip()' value='Stop ISDN and TCP Trace'>" .
				"<input type='hidden' name='ports' value='" . $ports . "'></td></tr>";
			//Wenn kein Port ausgewählt wurde, wird die Anfangstabelle angezeigt.
		} else {
			$ret .= "<br/><form class='extensions_form' method='POST'>
			<table class='contenttoc'>
			<tr><th colspan='2'>Full Trace</th></tr>
			<tr>
			<td>ISDN Ports</td><td>SIP</td>
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>enable
			<br/>
			<b>Check&nbsp;All</b>
			<input type='checkbox' id='checkall' onclick='checkallp();' onmouseover=\"Tip('".DEBUG_CHECK_ALL."')\" onmouseout='UnTip()'>
			<br/>" . $this->ports() . 
			"<br/>
			<br/>
			</td>
			<td>
			<input type='checkbox' name='sip_sign' id='sip_sign' value='1' onclick='if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;' checked/>Sip Sign
			<br/>
			<input type='checkbox' name='sip_audio' id='sip_audio' value='1' />Sip Audio
			</td>
			</tr>
			<tr>
			<td>
			<img src='./includes/images/punkt_rot.gif'></td>
			<td>
			<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_START_TRACE."')\" onmouseout='UnTip()' value='Start'>
			</td>
			</tr>";
		}
		/*Wenn man auf den Knopf Stop clickt, wird die Module mISDNdebugtool gekillt
		  und ein Link wir angezeigt um die erzeugten Dateien als eine tar.gz Datei
		  herunterzuladen.*/
	
	}elseif ($_POST['trace'] == "Stop ISDN and TCP Trace") {
		unset($_SESSION['IsdnTcp']);
		//*****EIN COOKIE WIRD IN DER DATEI HEADER.PHP GELÖSCHT*****
		system("/usr/bin/killall tcpdump");
		system("/usr/bin/killall mISDNdebugtool");
		system("/sbin/rmmod mISDN_debugtool");
		$query = $ba->select("select logging_active from general");
		while ($entry = $ba->fetch_array($query)) {
		}
		//Logging Einstellungen auf die gespeicherte Daten zurücksetzen
		$isgw = new isgwtelnet();	
  		$isgw->isgw_login();
  		$query = $ba->select("select logging_active from general");
		while ($entry = $ba->fetch_array($query)) {
			$isgw->logactive($entry['logging_active']);
		}
		$query = $ba->select("select loglevel from general");
		while ($entry = $ba->fetch_array($query)) {  
  			$isgw->loglevel($entry['loglevel']);
		}
		$isgw->lld();
		//tar.gz erzeugen
		exec("/bin/rm /tmp/DebugFiles.tar.gz");
		$splitports = split(',', $_POST['ports']);
		$files = "";

		foreach ($splitports as $value) {
			if (file_exists("/tmp/ISDNdebug-$value")) {
				if ($files != "")
					$files .= " ISDNdebug-" . $value;
				else
					$files .= "-C /tmp/ ISDNdebug-" . $value;
			}
		}
		if (file_exists("/tmp/tcpDump")) {
			if ($files != "")
				$files .= " tcpDump";
			else
				$files .= "-C /tmp/ tcpDump";
		}		
		if (file_exists("/tmp/tcpDump.lo")) {
			if ($files != "")
				$files .= " tcpDump.lo";
			else
				$files .= "-C /tmp/ tcpDump.lo";
		}
		
		$err_files=glob("/tmp/isgw.err*");
		foreach($err_files as $file) {
			//echo basename($file)."<br/>";
			$files.=" ".basename($file);
		}
		$log_files=glob("/tmp/isgw.log*");
		foreach($log_files as $file) {
			//echo basename($file)."<br/>";
			$files.=" ".basename($file);
		}
		$files.=" /usr/conf ";
		
		//echo $files;
		exec("/bin/tar -czf /tmp/DebugFiles.tar.gz " . $files);
		exec("/bin/rm /tmp/ISDNdebug*");
		exec("/bin/rm /tmp/tcpDump");
		$ba->set("trace","no");
		$ret .= "<br/><form class='extensions_form' method='POST'>
			<table class='contenttoc'>
			<tr><th colspan='2'>Full Trace</th></tr>
			<tr>
			<td>ISDN Ports</td><td>SIP</td>
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>enable
			<br/>
			<b>Check&nbsp;All</b>
			<input type='checkbox' id='checkall' onclick='checkallp();' onmouseover=\"Tip('".DEBUG_CHECK_ALL."')\" onmouseout='UnTip()'>
			<br/>" . $this->ports() . 
			"<br/>
			<br/>
			</td>
			<td>
			<input type='checkbox' name='sip_sign' id='sip_sign' value='1' onclick='if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;' checked/>Sip Sign
			<br/>
			<input type='checkbox' name='sip_audio' id='sip_audio' value='1' />Sip Audio
			</td>
			</tr>
			<tr>
			<td>
			<img src='./includes/images/punkt_rot.gif'>
			</td>
			<td>
			<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_START_TRACE."')\" onmouseout='UnTip()' value='Start'>
			</td>
			</tr>";
	}elseif ($ba->get("trace")=="yes"){
			$ret .= "<br/><form class='extensions_form' method='POST'>" .
				"<table class='contenttoc'><tr><th colspan='2'>Full Trace</th></tr><tr>" .
				"<td><img src='./includes/images/punkt_gruen.gif'></td>
				<td>
					<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_STOP_TRACE."')\" onmouseout='UnTip()' value='Stop ISDN and TCP Trace'>" .
					"<input type='hidden' name='ports' value='" . $ports . "'>
				</td></tr>";
	}
	
	if (file_exists("/tmp/debug-info.tar.gz") || file_exists("/tmp/DebugFiles.tar.gz")){
		$ret.="<tr><th colspan='2'>Downloads</th></tr>";
		if (file_exists("/tmp/debug-info.tar.gz"))
		$ret.="<tr>
			<td nowrap><b>Download ISGW Coredumps</b>&nbsp;&nbsp;
			<input type='button' value='Download' onclick=\" window.location.href='misc/isdn_trace.php?option=isgw';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' id='deletedatei' value='Delete file' onclick=\"javascript:if (confirm('Do you want to delete the ISGW Coredumps?')==true) window.location.href='misc/deletedatei.php';\" onmouseover=\"Tip('".DEBUG_DELETE."')\" onmouseout='UnTip()'></td>
			<td>".date("d M Y H:i",filectime("/tmp/debug-info.tar.gz"))."</td>
			</tr>";
		if (file_exists("/tmp/DebugFiles.tar.gz"))
		$ret.="<tr>
			<td nowrap><b>Debug Files</b>&nbsp;&nbsp;
			<input type='button' value='Download' onclick=\" window.location.href='misc/isdn_trace.php';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' id='deletedatei' value='Delete file' onclick=\"javascript:if (confirm('Do you want to delete the debug files?')==true) window.location.href='misc/deletedatei.php?option=debug';\" onmouseover=\"Tip('".DEBUG_DELETE_FILES."')\" onmouseout='UnTip()'>
			<td>".date("d M Y H:i",filectime("/tmp/DebugFiles.tar.gz"))."</td>
			</tr>";
		
	}
	$ret.="</form></table><br/>";
	
	//Rückgabe: Der Inhalt von der HTML-Seite  
	return $ret;
}
}
?>
